.. _orm_internal_toplevel:

ORM Internals
=============

Key ORM constructs, not otherwise covered in other
sections, are listed here.

.. currentmodule:: sqlalchemy.orm

.. autoclass:: AttributeState
    :members:

.. autoclass:: CascadeOptions
    :members:

.. autoclass:: ClassManager
    :members:

.. autoclass:: ColumnProperty
    :members:

.. autoclass:: Composite

.. autoclass:: CompositeProperty
    :members:

.. autoclass:: AttributeEventToken
    :members:

.. autoclass:: IdentityMap
    :members:

.. autoclass:: InspectionAttr
    :members:

.. autoclass:: InspectionAttrInfo
    :members:

.. autoclass:: InstanceState
    :members:


.. autoclass:: InstrumentedAttribute
    :members:

.. autoclass:: LoaderCallableStatus
    :members:

.. autoclass:: Mapped

.. autoclass:: MappedColumn

.. autoclass:: MapperProperty
    :members:

.. autoclass:: MappedSQLExpression

.. autoclass:: InspectionAttrExtensionType
    :members:

.. autoclass:: NotExtension
    :members:

.. autofunction:: merge_result

.. autofunction:: merge_frozen_result


.. autoclass:: PropComparator
    :members:
    :inherited-members:

.. autoclass:: Relationship

.. autoclass:: RelationshipDirection
    :members:

.. autoclass:: RelationshipProperty
  :members:

.. autoclass:: SQLORMExpression

.. autoclass:: Synonym

.. autoclass:: SynonymProperty
    :members:

.. autoclass:: QueryContext
    :members:


.. autoclass:: QueryableAttribute
    :members:

.. autoclass:: UOWTransaction
    :members:

